<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { isPlayerActive } from "./theResistance";

  const dispatch = createEventDispatcher();
  function performAction(action: Action) {
    dispatch("action", action);
  }

  export let variant: "above-board" | "below-board";
  export let state: GameState;
  export let phase: TeamVoteReveal;
  export let user: PlayerState | undefined;

  $: votes = Object.entries(phase.TeamVoteReveal.votes);
  $: voteSuccessful =
    votes.filter(([_playerId, vote]) => vote).length > votes.length / 2;

  $: naySayers = votes
    .filter(([_playerId, vote]) => !vote)
    .map(([playerId, _vote]) => parseInt(playerId));

  $: yeaSayer = votes
    .filter(([_playerId, vote]) => vote)
    .map(([playerId, _vote]) => parseInt(playerId));
</script>

{#if variant === "above-board"}
  <h3>
    {#if voteSuccessful}Vote succeeded!{:else}Vote failed!{/if}
  </h3>
{:else if variant === "below-board"}
  <div class="team-vote-reveal-prompt">
    <div class="vote-columns">
      <div>
        <h4>
          <span class="emoji">👎</span> Voted to reject
        </h4>

        <ul>
          {#each naySayers as playerId (playerId)}
            <li><gs6-user userid={playerId} /></li>
          {/each}
        </ul>
      </div>

      <div>
        <h4>
          <span class="emoji">👍</span> Voted to approve
        </h4>

        <ul>
          {#each yeaSayer as playerId (playerId)}
            <li><gs6-user userid={playerId} /></li>
          {/each}
        </ul>
      </div>
    </div>
    {#if user && isPlayerActive(state, user.id)}
      <button class="primary" on:click={() => performAction({ Ready: {} })}>
        I'm ready!
      </button>
    {/if}
  </div>
{/if}

<style>
  .team-vote-reveal-prompt {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .team-vote-reveal-prompt > * {
    margin: 0.5rem;
  }

  .vote-columns {
    width: 25rem;

    display: grid;
    grid-template-columns: 1fr 1fr;
    gap: 0;
  }

  .vote-columns > *:first-child {
    border-right: #aaaa solid 1px;
  }

  ul {
    display: flex;
    flex-direction: column;
    flex-wrap: wrap;
    max-height: 9rem;
    margin: 0;
  }
  li {
    margin: 0.125rem 0.5rem;
  }
  .vote-columns h4 {
    text-align: center;
    white-space: nowrap;
  }
</style>
